osl::PtypeDirectionTraits< T, D > Struct Template Reference

`#include <ptypeTraits.h>`

## Static Public Attributes

static const bool | hasMove =(PtypeTraits<T>::moveMask & DirectionTraits<D>::mask)!=0
static const bool | canMove
static const MoveConstraint | moveConstraint

## Detailed Description

template<Ptype T, Direction D>
struct osl::PtypeDirectionTraits< T, D >

Definition at line 339 of file ptypeTraits.h.

## Member Data Documentation

## canMove

template<Ptype T, Direction D>

const bool osl::PtypeDirectionTraits< T, D >::canMove

static

Initial value:
=
(PtypeTraits<T>::moveMask & DirectionTraits<D>::mask)!=0 ||
(PtypeTraits<T>::moveMask &
DirectionTraits<DirectionTraits<D>::longDir>::mask)!=0
osl::DirectionTraits
Definition directionTraits.h:225
osl::DirectionTraits::mask
static const unsigned int mask
Definition directionTraits.h:227
osl::DirectionTraits::longDir
static const Direction longDir
Definition directionTraits.h:233
osl::PtypeTraits
Definition ptypeTraits.h:12

Definition at line 342 of file ptypeTraits.h.

Referenced by osl::NumEffectState::hasEffectInDirection().

## hasMove

template<Ptype T, Direction D>

const bool osl::PtypeDirectionTraits< T, D >::hasMove =(PtypeTraits<T>::moveMask & DirectionTraits<D>::mask)!=0

static

Definition at line 341 of file ptypeTraits.h.

## moveConstraint

template<Ptype T, Direction D>

const MoveConstraint osl::PtypeDirectionTraits< T, D >::moveConstraint

static

Initial value:
=
(PtypeDirectionTraits<T,D>::canMove
? (PtypeDirectionTraits<PtypeFuns<T>::promotePtype,D>::canMove
? NoConstraint : OnlyBasic )
: (PtypeDirectionTraits<PtypeFuns<T>::promotePtype,D>::canMove
? OnlyPromoted : CannotMove))
osl::D
@ D
Definition basic_type.h:319
osl::NoConstraint
@ NoConstraint
promoteしていようが，いまいが可能
Definition ptypeTraits.h:335
osl::OnlyBasic
@ OnlyBasic
promoteしていない駒の場合にのみ可能
Definition ptypeTraits.h:333
osl::OnlyPromoted
@ OnlyPromoted
promote済みの駒の場合にのみ可能
Definition ptypeTraits.h:331
osl::CannotMove
@ CannotMove
可能でない
Definition ptypeTraits.h:329
osl::PtypeDirectionTraits
Definition ptypeTraits.h:340
osl::PtypeDirectionTraits::canMove
static const bool canMove
Definition ptypeTraits.h:342

Definition at line 346 of file ptypeTraits.h.

The documentation for this struct was generated from the following file:

- ptypeTraits.h